thunderbolt hotplug is broken

Bug #1577898 reported by Mario Limonciello on 2016-05-03
30
This bug affects 6 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
Medium
Joseph Salisbury
Trusty
Medium
Joseph Salisbury
Vivid
Medium
Joseph Salisbury
Wily
Medium
Joseph Salisbury
Xenial
Medium
Joseph Salisbury
Yakkety
Medium
Joseph Salisbury

Bug Description

Thunderbolt hotplug is broken on type-c ports. Redhat already submitted a patch for this that was accepted into upstream ACPICA, but it needs to be backported into Ubuntu's kernel.

I've verified that the patch works properly using a type-C USB Ethernet dongle as well as hot-plugging a Dell TB15 dock.

http://www.spinics.net/lists/linux-acpi/msg65578.html

tags: added: bot-stop-nagging

This bug is missing log files that will aid in diagnosing the problem. From a terminal window please run:

apport-collect 1577898

and then change the status of the bug to 'Confirmed'.

If, due to the nature of the issue you have encountered, you are unable to run this command, please add a comment stating that fact and change the bug status to 'Confirmed'.

This change has been made by an automated script, maintained by the Ubuntu Kernel Team.

Changed in linux (Ubuntu):
status: New → Incomplete
Changed in linux (Ubuntu Trusty):
status: New → Incomplete
Changed in linux (Ubuntu Xenial):
status: New → Incomplete
Changed in linux (Ubuntu Xenial):
status: Incomplete → Confirmed
Changed in linux (Ubuntu Trusty):
status: Incomplete → Confirmed
Changed in linux (Ubuntu):
status: Incomplete → Won't Fix
status: Won't Fix → Confirmed
Mario Limonciello (superm1) wrote :

There aren't logs for this. it's a request to backport a patch.

Mario Limonciello (superm1) wrote :

Here is the patch as submitted to LKML from ACPICA:
http://www.spinics.net/lists/linux-acpi/msg65737.html

Changed in linux (Ubuntu):
importance: Undecided → Medium
Changed in linux (Ubuntu Xenial):
importance: Undecided → Medium
Changed in linux (Ubuntu Trusty):
importance: Undecided → Medium
tags: added: kernel-da-key
Changed in linux (Ubuntu):
status: Confirmed → Triaged
Changed in linux (Ubuntu Trusty):
status: Confirmed → Triaged
Changed in linux (Ubuntu Xenial):
status: Confirmed → Triaged
Joseph Salisbury (jsalisbury) wrote :

It doesn't look like the patch landed in mainline as of yet. As soon as it does, we can cherry-pick it into the Ubuntu kernels.

Mario Limonciello (superm1) wrote :

Why do you have to wait for it to be in mainline to cherry pick? It's already in rafael's linux-pm acpica-fixes branch with a CC to stable all applicable.

https://git.kernel.org/cgit/linux/kernel/git/rafael/linux-pm.git/commit/?h=acpica-fixes&id=93d68841a23a5779cef6fb9aa0ef32e7c5bd00da

Joseph Salisbury (jsalisbury) wrote :

We generally like patches to land in mainline before applying them to the Ubuntu kernel as a SAUCE patch. This can prevent issues if the patch changes before it actually gets accepted into mainline.

However, this patch looks fairly small, so I'll build a test kernel with it and post it shortly.

Changed in linux (Ubuntu):
status: Triaged → In Progress
assignee: nobody → Joseph Salisbury (jsalisbury)
Changed in linux (Ubuntu Trusty):
assignee: nobody → Joseph Salisbury (jsalisbury)
Changed in linux (Ubuntu Xenial):
assignee: nobody → Joseph Salisbury (jsalisbury)
Changed in linux (Ubuntu Trusty):
status: Triaged → In Progress
Changed in linux (Ubuntu Xenial):
status: Triaged → In Progress
Joseph Salisbury (jsalisbury) wrote :

I built a Xenial text kernel with the patch. The test kernel can be downloaded from:

http://kernel.ubuntu.com/~jsalisbury/lp1577898/

Can you test this kernel and see if it resolves this bug?

Hi Joseph,

Yes, thank you. I just tested with a Dell USB Type-C ethernet adapter (PN#
96NP5). In the existing latest Xenial kernel hotplug did not work. Device
wasn't present in lsusb.
After installing that kernel i'm able to hotplug and device is present in
lsusb.

Thanks,

On Fri, May 6, 2016 at 11:25 AM Joseph Salisbury <
<email address hidden>> wrote:

> I built a Xenial text kernel with the patch. The test kernel can be
> downloaded from:
>
> http://kernel.ubuntu.com/~jsalisbury/lp1577898/
>
> Can you test this kernel and see if it resolves this bug?
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1577898
>
> Title:
> thunderbolt hotplug is broken
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ubuntu/+source/linux/+bug/1577898/+subscriptions
>

Changed in linux (Ubuntu Vivid):
status: New → In Progress
Changed in linux (Ubuntu Wily):
status: New → In Progress
Changed in linux (Ubuntu Vivid):
importance: Undecided → Medium
Changed in linux (Ubuntu Wily):
importance: Undecided → Medium
Changed in linux (Ubuntu Vivid):
assignee: nobody → Joseph Salisbury (jsalisbury)
Changed in linux (Ubuntu Wily):
assignee: nobody → Joseph Salisbury (jsalisbury)
Kyle Gochenour (kyle-gochenour) wrote :

I have duplicate bug #1571859 and tried the kernel above from jsalisbury and it did not work for me. However there is a chance that I may just suck at dealing with kernels though.
(I installed all the packages except for the Cloud Tools.)

Mario Limonciello (superm1) wrote :

Kyle,
Can you confirm from 'uname -a' what output you have?

That will confirm if you are booted into jsalisbury's kernel.

On Mon, May 9, 2016 at 5:10 PM Kyle Gochenour <email address hidden>
wrote:

> I have duplicate bug #1571859 and tried the kernel above from jsalisbury
> and it did not work for me. However there is a chance that I may just suck
> at dealing with kernels though.
> (I installed all the packages except for the Cloud Tools.)
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1577898
>
> Title:
> thunderbolt hotplug is broken
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ubuntu/+source/linux/+bug/1577898/+subscriptions
>

Mario,
I found the issue. I am running 4.6.0-040600rc4-generic from testing in my bug report. I had install jsalisbury's kernel but was not booting into it. I hit GRUB on the reboot and booted into 4.4.0-21 which matches his kernel.

I get this now for uname -a:
Linux yeti 4.4.0-21-generic #37-Ubuntu SMP Mon Apr 18 18:33:37 UTC 2016 x86_64 x86_64 x86_64 GNU/Linux

But hotplug does not work still. Again, I still could be screwing up changing up the kernels, so take with a large grain of salt.

Mario Limonciello (superm1) wrote :

You're still booted into the wrong one. His kernel would show a ~lp##### in
the uname string. The one your are booted into is probably the one from the
archive that overwrote his on an apt update.

Install his again, don't do apt updates and try to boot into it.

On Mon, May 9, 2016, 18:05 Kyle Gochenour <email address hidden> wrote:

> Mario,
> I found the issue. I am running 4.6.0-040600rc4-generic from testing in my
> bug report. I had install jsalisbury's kernel but was not booting into it.
> I hit GRUB on the reboot and booted into 4.4.0-21 which matches his kernel.
>
> I get this now for uname -a:
> Linux yeti 4.4.0-21-generic #37-Ubuntu SMP Mon Apr 18 18:33:37 UTC 2016
> x86_64 x86_64 x86_64 GNU/Linux
>
> But hotplug does not work still. Again, I still could be screwing up
> changing up the kernels, so take with a large grain of salt.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1577898
>
> Title:
> thunderbolt hotplug is broken
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ubuntu/+source/linux/+bug/1577898/+subscriptions
>

That was it, thanks Mario:
Linux yeti 4.4.0-21-generic #37~lp1577898 SMP Fri May 6 16:01:15 UTC 2016 x86_64 x86_64 x86_64 GNU/Linux

I can confirm that I can hotplug my Dell USB-C to ethernet adapter, as well as my Nexus6p with a USB-C to USB-C cord as well.

So the patch is working for me as well. What does the process involve from here? (first time dealing with a bug here).

Mario Limonciello (superm1) wrote :

Nothing else required from you. It's the Ubuntu kernel team SRU process
from here on out. Joseph might be able to comment better on the expected
timing this will land in a new kernel version.

On Mon, May 9, 2016 at 7:15 PM Kyle Gochenour <email address hidden>
wrote:

> That was it, thanks Mario:
> Linux yeti 4.4.0-21-generic #37~lp1577898 SMP Fri May 6 16:01:15 UTC 2016
> x86_64 x86_64 x86_64 GNU/Linux
>
>
> I can confirm that I can hotplug my Dell USB-C to ethernet adapter, as
> well as my Nexus6p with a USB-C to USB-C cord as well.
>
> So the patch is working for me as well. What does the process involve
> from here? (first time dealing with a bug here).
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1577898
>
> Title:
> thunderbolt hotplug is broken
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ubuntu/+source/linux/+bug/1577898/+subscriptions
>

Changed in linux (Ubuntu Trusty):
status: In Progress → Fix Committed
Changed in linux (Ubuntu Vivid):
status: In Progress → Fix Committed
Changed in linux (Ubuntu Wily):
status: In Progress → Fix Committed
Changed in linux (Ubuntu Xenial):
status: In Progress → Fix Committed
Joseph Salisbury (jsalisbury) wrote :

@Kyle, the fix has been commited to -proposed. The current SRU cycle is expected to be released to -updates on May 30th.

Kamal Mostafa (kamalmostafa) wrote :

This bug is awaiting verification that the kernel in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-trusty' to 'verification-done-trusty'.

If verification is not done by 5 working days from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-trusty
tags: added: verification-needed-vivid
Kamal Mostafa (kamalmostafa) wrote :

This bug is awaiting verification that the kernel in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-vivid' to 'verification-done-vivid'.

If verification is not done by 5 working days from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-wily
Kamal Mostafa (kamalmostafa) wrote :

This bug is awaiting verification that the kernel in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-wily' to 'verification-done-wily'.

If verification is not done by 5 working days from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-xenial
Kamal Mostafa (kamalmostafa) wrote :

This bug is awaiting verification that the kernel in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-xenial' to 'verification-done-xenial'.

If verification is not done by 5 working days from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

Mario Limonciello (superm1) wrote :

Hi,

I verified the kernel in xenial works properly for hotplugging the TB15.

Linux test-Precision-5510 4.4.0-23-generic #41-Ubuntu SMP Mon May 16 23:04:25 UTC 2016 x86_64 x86_64 x86_64 GNU/Linux

Does there really need to be a validation done on every other OS too or this gets dropped from earlier -proposed kernels?

tags: added: verification-done-xenial
removed: verification-needed-xenial
Kamal Mostafa (kamalmostafa) wrote :

Thanks for validating Xenial, Mario.

We appreciate getting validation for as many versions as possible, but no, we're not really going to drop this fix from the earlier versions.

Launchpad Janitor (janitor) wrote :
Download full text (16.9 KiB)

This bug was fixed in the package linux - 4.4.0-23.41

---------------
linux (4.4.0-23.41) xenial; urgency=low

  [ Kamal Mostafa ]

  * Release Tracking Bug
    - LP: #1582431

  * zfs: disable module checks for zfs when cross-compiling (LP: #1581127)
    - [Packaging] disable zfs module checks when cross-compiling

  * Xenial update to v4.4.10 stable release (LP: #1580754)
    - Revert "UBUNTU: SAUCE: (no-up) ACPICA: Dispatcher: Update thread ID for
      recursive method calls"
    - Revert "UBUNTU: SAUCE: nbd: ratelimit error msgs after socket close"
    - Revert: "powerpc/tm: Check for already reclaimed tasks"
    - RDMA/iw_cxgb4: Fix bar2 virt addr calculation for T4 chips
    - ipvs: handle ip_vs_fill_iph_skb_off failure
    - ipvs: correct initial offset of Call-ID header search in SIP persistence
      engine
    - ipvs: drop first packet to redirect conntrack
    - mfd: intel-lpss: Remove clock tree on error path
    - nbd: ratelimit error msgs after socket close
    - ata: ahci_xgene: dereferencing uninitialized pointer in probe
    - mwifiex: fix corner case association failure
    - CNS3xxx: Fix PCI cns3xxx_write_config()
    - clk-divider: make sure read-only dividers do not write to their register
    - soc: rockchip: power-domain: fix err handle while probing
    - clk: rockchip: free memory in error cases when registering clock branches
    - clk: meson: Fix meson_clk_register_clks() signature type mismatch
    - clk: qcom: msm8960: fix ce3_core clk enable register
    - clk: versatile: sp810: support reentrance
    - clk: qcom: msm8960: Fix ce3_src register offset
    - lpfc: fix misleading indentation
    - ath9k: ar5008_hw_cmn_spur_mitigate: add missing mask_m & mask_p
      initialisation
    - mac80211: fix statistics leak if dev_alloc_name() fails
    - tracing: Don't display trigger file for events that can't be enabled
    - MD: make bio mergeable
    - Minimal fix-up of bad hashing behavior of hash_64()
    - mm, cma: prevent nr_isolated_* counters from going negative
    - mm/zswap: provide unique zpool name
    - ARM: EXYNOS: Properly skip unitialized parent clock in power domain on
    - ARM: SoCFPGA: Fix secondary CPU startup in thumb2 kernel
    - xen: Fix page <-> pfn conversion on 32 bit systems
    - xen/balloon: Fix crash when ballooning on x86 32 bit PAE
    - xen/evtchn: fix ring resize when binding new events
    - HID: wacom: Add support for DTK-1651
    - HID: Fix boot delay for Creative SB Omni Surround 5.1 with quirk
    - Input: zforce_ts - fix dual touch recognition
    - proc: prevent accessing /proc/<PID>/environ until it's ready
    - mm: update min_free_kbytes from khugepaged after core initialization
    - batman-adv: fix DAT candidate selection (must use vid)
    - batman-adv: Check skb size before using encapsulated ETH+VLAN header
    - batman-adv: Fix broadcast/ogm queue limit on a removed interface
    - batman-adv: Reduce refcnt of removed router when updating route
    - writeback: Fix performance regression in wb_over_bg_thresh()
    - MAINTAINERS: Remove asterisk from EFI directory names
    - x86/tsc: Read all ratio bits from MSR_PLATFORM_INFO
    - ARM: cpuidle: Pass on arm_cpuidle_s...

Changed in linux (Ubuntu Yakkety):
status: In Progress → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 3.13.0-87.133

---------------
linux (3.13.0-87.133) trusty; urgency=low

  [ Kamal Mostafa ]

  * Release Tracking Bug
    - LP: #1585315

  [ Upstream Kernel Changes ]

  * Revert "usb: hub: do not clear BOS field during reset device"
    - LP: #1582864

linux (3.13.0-87.132) trusty; urgency=low

  [ Kamal Mostafa ]

  * Release Tracking Bug
    - LP: #1582398

  [ Kamal Mostafa ]

  * [Config] Drop ozwpan from the ABI

  [ Luis Henriques ]

  * [Config] CONFIG_USB_WPAN_HCD=n
    - LP: #1463740
    - CVE-2015-4004

  [ Prarit Bhargava ]

  * SAUCE: (no-up) ACPICA: Dispatcher: Update thread ID for recursive
    method calls
    - LP: #1577898

  [ Upstream Kernel Changes ]

  * usbnet: cleanup after bind() in probe()
    - LP: #1567191
    - CVE-2016-3951
  * KVM: x86: bit-ops emulation ignores offset on 64-bit
    - LP: #1423672
  * USB: usbip: fix potential out-of-bounds write
    - LP: #1572666
    - CVE-2016-3955
  * x86/mm/32: Enable full randomization on i386 and X86_32
    - LP: #1568523
    - CVE-2016-3672
  * Input: gtco - fix crash on detecting device without endpoints
    - LP: #1575706
    - CVE-2016-2187
  * atl2: Disable unimplemented scatter/gather feature
    - LP: #1561403
    - CVE-2016-2117
  * ALSA: usb-audio: Skip volume controls triggers hangup on Dell USB Dock
    - LP: #1577905
  * fs/pnode.c: treat zero mnt_group_id-s as unequal
    - LP: #1572316
  * propogate_mnt: Handle the first propogated copy being a slave
    - LP: #1572316
  * drm: Balance error path for GEM handle allocation
    - LP: #1579610
  * x86/mm: Add barriers and document switch_mm()-vs-flush synchronization
    - LP: #1538429
    - CVE-2016-2069
  * x86/mm: Improve switch_mm() barrier comments
    - LP: #1538429
    - CVE-2016-2069
  * net: fix infoleak in llc
    - LP: #1578496
    - CVE-2016-4485
  * net: fix infoleak in rtnetlink
    - LP: #1578497
    - CVE-2016-4486

 -- Kamal Mostafa <email address hidden> Tue, 24 May 2016 11:04:30 -0700

Changed in linux (Ubuntu Trusty):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 3.19.0-61.69

---------------
linux (3.19.0-61.69) vivid; urgency=low

  [ Kamal Mostafa ]

  * CVE-2016-1583 (LP: #1588871)
    - ecryptfs: fix handling of directory opening
    - SAUCE: proc: prevent stacking filesystems on top
    - SAUCE: ecryptfs: forbid opening files without mmap handler
    - SAUCE: sched: panic on corrupted stack end

 -- Andy Whitcroft <email address hidden> Wed, 08 Jun 2016 22:25:58 +0100

Changed in linux (Ubuntu Vivid):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 4.2.0-38.45

---------------
linux (4.2.0-38.45) wily; urgency=low

  [ Kamal Mostafa ]

  * CVE-2016-1583 (LP: #1588871)
    - ecryptfs: fix handling of directory opening
    - SAUCE: proc: prevent stacking filesystems on top
    - SAUCE: ecryptfs: forbid opening files without mmap handler
    - SAUCE: sched: panic on corrupted stack end

 -- Andy Whitcroft <email address hidden> Wed, 08 Jun 2016 22:10:39 +0100

Changed in linux (Ubuntu Wily):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 4.4.0-24.43

---------------
linux (4.4.0-24.43) xenial; urgency=low

  [ Kamal Mostafa ]

  * CVE-2016-1583 (LP: #1588871)
    - ecryptfs: fix handling of directory opening
    - SAUCE: proc: prevent stacking filesystems on top
    - SAUCE: ecryptfs: forbid opening files without mmap handler
    - SAUCE: sched: panic on corrupted stack end

  * arm64: statically link rtc-efi (LP: #1583738)
    - [Config] Link rtc-efi statically on arm64

 -- Kamal Mostafa <email address hidden> Fri, 03 Jun 2016 10:02:16 -0700

Changed in linux (Ubuntu Xenial):
status: Fix Committed → Fix Released
FireBurn (fireburn) wrote :

A patch https://patchwork.kernel.org/patch/10212201/ is going to fix this issue properly, it should be backported to older kernels too, so hopefully going forward your USB-C connectors will work correctly, it also fixes NVMe drives disappearing after suspend too

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers